require "screenpress/version"
require "capybara"

module Screenpress
  autoload :Config,    'screenpress/config'
  autoload :DSL,       'screenpress/dsl'
  autoload :Saver,     'screenpress/saver'

  module Compare
    autoload :Bits,    'screenpress/compare/bits'
    autoload :Phashion, 'screenpress/compare/phashion'
  end

  class << self
    def config
      @config ||= Screenpress::Config.new
    end

    protected

    def reset
      # mostly for tests, resets eveything
      @config = nil
    end
  end
end
