require 'phashion'

module Screenpress
  module Compare
    class Phashion
      attr_reader :orig_image, :fresh_image, :difference
      def initialize(orig_path, fresh_path)
        @orig_image  = ::Phashion::Image.new(orig_path)
        @fresh_image = ::Phashion::Image.new(fresh_path)
      end

      def difference
        orig_print  = orig_image.fingerprint
        fresh_print = fresh_image.fingerprint
        ::Phashion.hamming_distance(orig_print, fresh_print)
      end

      def threshold
        Screenpress.config.threshold || 15
      end
    end
  end
end
